var SGXSniffer = {
    COMMON_INFO: {
        "snifferRules": {
            "suffixRules": {
//                "zip": {
//                    "type": "compress",
//                    "typeDescription": "压缩",
//                    "iconUrl": "http://download.mse.sogou.com/resourcesniffer/icon/resource_sniffer_compress_type_40_40.png"
//                },
//                "rar": {
//                    "type": "compress",
//                    "typeDescription": "压缩",
//                    "iconUrl": "http://download.mse.sogou.com/resourcesniffer/icon/resource_sniffer_compress_type_40_40.png"
//                },
//                "7z": {
//                    "type": "compress",
//                    "typeDescription": "压缩",
//                    "iconUrl": "http://download.mse.sogou.com/resourcesniffer/icon/resource_sniffer_compress_type_40_40.png"
//                },
                "epub": {
                    "type": "ebook",
                    "typeDescription": "电子书",
                    "iconUrl": "http://download.mse.sogou.com/resourcesniffer/icon/resource_sniffer_ebook_type_40_40.png"
                },
                "txt": {
                    "type": "ebook",
                    "typeDescription": "电子书",
                    "iconUrl": "http://download.mse.sogou.com/resourcesniffer/icon/resource_sniffer_ebook_type_40_40.png"
                },
                "pdf": {
                    "type": "ebook",
                    "typeDescription": "电子书",
                    "iconUrl": "http://download.mse.sogou.com/resourcesniffer/icon/resource_sniffer_ebook_type_40_40.png"
                },
                "rm": {
                    "type": "video",
                    "typeDescription": "视频",
                    "iconUrl": "http://download.mse.sogou.com/resourcesniffer/icon/resource_sniffer_video_type_40_40.png"
                },
                "rmvb": {
                    "type": "video",
                    "typeDescription": "视频",
                    "iconUrl": "http://download.mse.sogou.com/resourcesniffer/icon/resource_sniffer_video_type_40_40.png"
                },
                "mkv": {
                    "type": "video",
                    "typeDescription": "视频",
                    "iconUrl": "http://download.mse.sogou.com/resourcesniffer/icon/resource_sniffer_video_type_40_40.png"
                },
                "avi": {
                    "type": "video",
                    "typeDescription": "视频",
                    "iconUrl": "http://download.mse.sogou.com/resourcesniffer/icon/resource_sniffer_video_type_40_40.png"
                },
                "mpg": {
                    "type": "video",
                    "typeDescription": "视频",
                    "iconUrl": "http://download.mse.sogou.com/resourcesniffer/icon/resource_sniffer_video_type_40_40.png"
                },
                "wmv": {
                    "type": "video",
                    "typeDescription": "视频",
                    "iconUrl": "http://download.mse.sogou.com/resourcesniffer/icon/resource_sniffer_video_type_40_40.png"
                },
                "3gp": {
                    "type": "video",
                    "typeDescription": "视频",
                    "iconUrl": "http://download.mse.sogou.com/resourcesniffer/icon/resource_sniffer_video_type_40_40.png"
                },
                "flv": {
                    "type": "video",
                    "typeDescription": "视频",
                    "iconUrl": "http://download.mse.sogou.com/resourcesniffer/icon/resource_sniffer_video_type_40_40.png"
                },
                "mp4": {
                    "type": "video",
                    "typeDescription": "视频",
                    "iconUrl": "http://download.mse.sogou.com/resourcesniffer/icon/resource_sniffer_video_type_40_40.png"
                },
                "mp3": {
                    "type": "audio",
                    "typeDescription": "音频",
                    "iconUrl": "http://download.mse.sogou.com/resourcesniffer/icon/resource_sniffer_audio_type_40_40.png"
                },
                "wma": {
                    "type": "audio",
                    "typeDescription": "音频",
                    "iconUrl": "http://download.mse.sogou.com/resourcesniffer/icon/resource_sniffer_audio_type_40_40.png"
                },
                "wav": {
                    "type": "audio",
                    "typeDescription": "音频",
                    "iconUrl": "http://download.mse.sogou.com/resourcesniffer/icon/resource_sniffer_audio_type_40_40.png"
                },
                "aac": {
                    "type": "audio",
                    "typeDescription": "音频",
                    "iconUrl": "http://download.mse.sogou.com/resourcesniffer/icon/resource_sniffer_audio_type_40_40.png"
                },
                "ogg": {
                    "type": "audio",
                    "typeDescription": "音频",
                    "iconUrl": "http://download.mse.sogou.com/resourcesniffer/icon/resource_sniffer_audio_type_40_40.png"
                },
                "ape": {
                    "type": "audio",
                    "typeDescription": "音频",
                    "iconUrl": "http://download.mse.sogou.com/resourcesniffer/icon/resource_sniffer_audio_type_40_40.png"
                },
                "flac": {
                    "type": "audio",
                    "typeDescription": "音频",
                    "iconUrl": "http://download.mse.sogou.com/resourcesniffer/icon/resource_sniffer_audio_type_40_40.png"
                },
                "qsed": {
                    "type": "qvod",
                    "typeDescription": "快播",
                    "iconUrl": "http://download.mse.sogou.com/resourcesniffer/icon/resource_sniffer_video_type_40_40.png"
                }
            },
            "protocolRules": {
                "thunder": {
                    "type": "thunder",
                    "typeDescription": "迅雷",
                    "iconUrl": "http://download.mse.sogou.com/resourcesniffer/icon/resource_sniffer_torrent_type_40_40.png"
                },
                "ed2k": {
                    "type": "ed2k",
                    "typeDescription": "电驴",
                    "iconUrl": "http://download.mse.sogou.com/resourcesniffer/icon/resource_sniffer_torrent_type_40_40.png"
                }
//                "qvod": {
//                    "type": "qvod",
//                    "typeDescription": "快播",
//                    "iconUrl": "http://download.mse.sogou.com/resourcesniffer/icon/resource_sniffer_video_type_40_40.png"
//                }
            }
        },
        "renderArr": [],
        "downloadAllArr": []
    },
    pickProtocol: function(str) {
        return str.split(':')[0];
    },
    $: function(selector) {
        return document.querySelector(selector);
    },
    $$: function(selector, context) {
        return (context || document).querySelectorAll(selector);
    },
    pick: function(str, type) {
        if (type === "protocol") {
            return str;
        }
        var strArr = str.split("?")[0].split("/").pop().split(".");
        var title = strArr[0];
        var suffix = strArr[1];

        return {
            title: title,
            suffix: suffix
        }
    },
    isMatched: function(value) {
        if(value && !this.filterSameLink(value)) {
            var tempObj = {};
            if (this.pickProtocol(value) in this.COMMON_INFO.snifferRules.protocolRules) {
                //协议匹配
                for(var key in this.COMMON_INFO.snifferRules.protocolRules[this.pickProtocol(value)]) {
                    tempObj[key] = this.COMMON_INFO.snifferRules.protocolRules[this.pickProtocol(value)][key];
                }
                tempObj.link = value;
                tempObj.title = this.pick(value, 'protocol');
            } else if(this.pick(value).suffix in this.COMMON_INFO.snifferRules.suffixRules) {
                //扩展名匹配
                for(var key in this.COMMON_INFO.snifferRules.suffixRules[this.pick(value).suffix]) {
                    tempObj[key] = this.COMMON_INFO.snifferRules.suffixRules[this.pick(value).suffix][key];
                }
                tempObj.link = value;
                var pickVal = this.pick(value);
                tempObj.title = pickVal.title;
                tempObj.suffix = pickVal.suffix;
            }
            !!Object.keys(tempObj).length && this.COMMON_INFO.renderArr.push(tempObj);
        }
    },
    isMatchedSrc: function(value) {
        // [2015-12-18] 针对 video 标签，只要其 src 中包含 ://，则视为有效 src
        if (value && value.indexOf('://') > -1 && !this.filterSameLink(value)) {
            var tempObj = {},
                pickVal = this.pick(value);
            tempObj.link = tempObj.title = value;

            if (pickVal.suffix) tempObj.suffix = pickVal.suffix;

            this.COMMON_INFO.renderArr.push(tempObj);
        }
    },
    filterSameLink: function(curlink) {
        this.COMMON_INFO.renderArr.some(function(item) {
            return item.link === curlink
        });
    },
    toArray: function(arrayLike) {
        return [].slice.apply(arrayLike);
    },
    doSniffer: function() {
        var self = this;
        // 嗅探的标签包括：<a> <audio> <video> <source> <object> <param> <embed>
        var tagAs = self.toArray(self.$$('a'));
        var tagAudios = self.toArray(self.$$('audio'));
        var tagVideos = self.toArray(self.$$('video'));
        var tagSources = self.toArray(self.$$('source'));
        var tagObjects = self.toArray(self.$$('object'));
        var tagParams = self.toArray(self.$$('param'));
        var tagEmbeds = self.toArray(self.$$('embed'));

        tagAs.length && tagAs.forEach(function(item) {
            self.isMatched(item.getAttribute("href") || item.getAttribute('thunderhref'));
        });
        tagAudios.length && tagAudios.forEach(function(item) {
            self.isMatched(item.getAttribute("src"));
        });
        tagVideos.length && tagVideos.forEach(function(item) {
            self.isMatchedSrc(item.getAttribute("src"));
        });
        tagSources.length && tagSources.forEach(function(item) {
            self.isMatched(item.getAttribute("src"));
        });
        tagObjects.length && tagObjects.forEach(function(item) {
            self.isMatched(item.getAttribute("data"));
        });
        tagParams.length && tagParams.forEach(function(item) {
            self.isMatched(item.getAttribute("value"));
        });
        tagEmbeds.length && tagEmbeds.forEach(function(item) {
            self.isMatched(item.getAttribute("src"));
        });

        if (this.COMMON_INFO.renderArr.length) {
            console.log({
                "list": this.COMMON_INFO.renderArr
            });
            return {
                "list": this.COMMON_INFO.renderArr
            }
        }
    }
};

// 入口
SGXSniffer.doSniffer();