/**
* @param ext
 * @param callbackid
 * @returns  回调的函数
 * sogoumse_exts 全局变量
 */
function contentScriptGetCallback(ext, callbackid) {
    for (var i = 0; i < sogoumse_exts.length; i++) {
        var closure = sogoumse_exts[i];
      	 log(closure.sogoumse.name + ext);
        if (closure.sogoumse.name == ext) {
        	log('contentScriptGetCallback');
        	log(callbackid);
        	log(closure.sogoumse.callbacks[callbackid]);
            return closure.sogoumse.callbacks[callbackid];
        }
        continue;
    }
    return null;
}

function excuteScriptInClosure(ext,code,cb){
   // console.log(  'excuteScriptInClosure --->'  + 'name = ' + ext + ' cb ' + cb );
    for(var i = 0; i < this.sogoumse_exts.length; i++){
        var sogoumse = this.sogoumse_exts[i].sogoumse;
        if (sogoumse.name === ext){
           return this.sogoumse_exts[i].excuteScript(code, cb);
        }
    }
}

function backgroundScriptCallback(ext,response,cb){
    //console.log( 'backgroundScriptCallback --->'  + 'name = ' + ext + ' cb ' + cb );
    sogoumse_interface.contentCallback(ext,JSON.stringify(response),cb+'');
}

function MessageSender(tabid, id, url) {
    this.tabid = tabid;
    this.id = id;
    this.url = url;

    
};

function addCallback(sogoumse, callback){
    if(typeof callback === "function"){
//        var id =''+ ((new Date()).getTime())%1000000;
//        id += (callback.toString()).length%1000;
//        id += Math.ceil(Math.random()*10000);
//        id = parseInt(id);
//        log('addCallback id:'+id);
//        sogoumse.callbacks[id]=callback;
//        return  id+"";

        // 在12306插件上值大于9位时将出现异常, 原因暂不明确, 为了尽快解决问题, 先将此值改为9位 by liwenhao on 2016-12-11
        var id = Math.floor(100000000 + Math.random() * 900000000);
        sogoumse.callbacks[id] = callback;
        return  id + "";
    }
}

function Event(name, sogoumse) {
    this.name = name;
    this.sogoumse = sogoumse;
    this.addListener = function (callback) {
    	 var index = addCallback(this.sogoumse,callback);
    	 log(sogoumse.name+"  "+sogoumse.url);
    	 log("Event : name   " + name +" "  +  index);
    	 log(callback);
        sogoumse_interface.addlistener(this.name ,this.sogoumse.name,index);
    };
}

function tab (id, url, isbackground, title, faviconurl) {
    this.id = id;
    this.title = title;
    this.url = url;
    this.isbackground = isbackground;
    this.faviconurl = faviconurl;
}

function Layer(sogoumse){
    this.sogoumse = sogoumse;

    this.onMessage  = new Event("layeronmessage", this.sogoumse);

    this.create = function(properties, callback) {
        if(typeof callback === 'undefined'){
            callback = function(){};
        }
        var index = addCallback(this.sogoumse, callback);
        sogoumse_interface.createLayer(this.sogoumse.name, JSON.stringify(properties), index);
    };

    this.sendMessage = function (tabid, message, callback) {
        if (typeof callback === 'undefined') {
            callback = function(){};
        }
        var index = addCallback(this.sogoumse, callback);
        sogoumse_interface.sendMessageToContentJS(tabid, this.sogoumse.name, JSON.stringify(message), index, "layeronmessage");
    }

    this.resize = function(properties, callback) {
        if (typeof callback === 'undefined') {
            callback = function(){};
        }
        var index = addCallback(this.sogoumse, callback);
        sogoumse_interface.resizeLayer(this.sogoumse.name, JSON.stringify(properties), index);
    }

    this.remove = function(tabId) {
        if (typeof tabId === 'undefined') { // 未给定tabId参数时的处理
            if(typeof tabid != 'undefined') {
                // 从前台页面调用删除浮层时可以不指定Tab ID，默认使用当前Tab的ID
                sogoumse_interface.removeLayer(tabid);
            }
        } else {
            sogoumse_interface.removeLayer(tabId);
        }
    }
}

function Tabs(sogoumse) {
    this.sogoumse = sogoumse;
    this.layer = new Layer(this.sogoumse);
    
    this.onMessage  = new Event("tabsonmessage", this.sogoumse);
    this.onUpdated  = new Event("tabsonupdate", this.sogoumse);
    this.onRemoved  = new Event("tabsonremove", this.sogoumse);
    this.onCreated   = new Event("tabsoncreate", this.sogoumse);
    this.onActived   = new Event("tabsonactive",this.sogoumse);
    
    // Sends a  message to the content script(s) in the specified tab
    this.sendMessage = function (tabid, message, callback) {
        if(typeof callback === 'undefined'){
            callback = function(){};
        }
    	var index = addCallback(this.sogoumse,callback);
        sogoumse_interface.sendMessageToContentJS(tabid,this.sogoumse.name ,JSON.stringify(message),index,"tabsonmessage");
    };   
    
     this.openUrl = function (url){
    	 if(typeof url == "string"){
          sogoumse_interface.openUrl(this.sogoumse.name,url);
    	 }
     };
     
    this.get = function (tabid, callback) {
    	var index = addCallback(this.sogoumse,callback);
        sogoumse_interface.getTab(tabid,this.sogoumse.name ,index ); 
    };

    this.reload = function (tabid, callback) {
       var index = addCallback(this.sogoumse,callback);
       sogoumse_interface.reloadTab(  tabid.toString() , this.sogoumse.name, index);
    }; 
   
    this.excuteScript = function (tabid, injectDetail, callback) {
    	  var index = addCallback(this.sogoumse,callback);
          sogoumse_interface.excuteScript(tabid ,this.sogoumse.name,JSON.stringify(injectDetail),index);
    };
  
    this.getCurrent = function (callback) {
    	  var index = addCallback(this.sogoumse,callback);
    	  sogoumse_interface.getCurrent(this.sogoumse.name ,index.toString()); 
    };
    
    this.create = function (createProperties, callback) {
    	var index = addCallback(this.sogoumse,callback);
    	log("create " + "index " + index + " details " + JSON.stringify(createProperties));
        sogoumse_interface.createTab( this.sogoumse.name , JSON.stringify(createProperties) , index);
    };
    
    this.update = function(tabid, updatePropertise,callback ){
    	var index = addCallback(this.sogoumse,callback);
        sogoumse_interface.update( this.sogoumse.name ,tabid,  JSON.stringify(updatePropertise), index);
    };
   
    
    this.remove = function(tabids ,callback){
        var index = addCallback(this.sogoumse,callback);
       if(typeof tabids==='object' && tabids.constructor===Array){
    	 for(var i=0, size = tabids.length; i < size ; i++ ){
    		 sogoumse_interface.removeTab(tabids[i]+"",  this.sogoumse.name, index);
    		 }
    	 }else if(typeof tabids==='number'){
    		 sogoumse_interface.removeTab( tabids , this.sogoumse.name ,index );
    	 } 
    };
};

function Extension(sogoumse) {
    this.sogoumse = sogoumse;
    this.onMessage = new Event("extensiononmessage", this.sogoumse);
    // content script send a massage to background js 
    this.sendMessage = function (message, callback) {
        if(typeof callback === 'undefined'){
            callback = function(){};
        }

//        var index = addCallback(this.sogoumse,callback);

        // HACK HERE. ATTENTION!
        // 不要将此处重构为调用#addCallback函数, 虽然在测试组提供的测试插件上运行正确, 但在12306插件上
        // #addCallback函数无法调用执行, 原因不明确, 为了尽快解决问题, 直接将#addCallback的实现放在这里
        var index = Math.floor(100000000 + Math.random() * 900000000);
        this.sogoumse.callbacks[index] = callback;

        // tabid 为全局变量，闭包创创建里初始化
        var url = document.location.href;
        sogoumse_interface.sendMessageToBackground( tabid , this.sogoumse.name , url, JSON.stringify(message) ,index + "");
    };
}

function QuickLaunch(sogoumse){
	this.sogoumse = sogoumse;
	this.onClicked =  new Event("quicklaunchonclick", this.sogoumse);
    this.showRedDot = function(visiable){
     sogoumse_interface.showRedDot(this.sogoumse.name, visiable);
    }
}

function BrowserAction(sogoumse) {
    this.sogoumse = sogoumse;
    this.getBadgeText = function (callback) {}; // callback format function (string result) {};
    this.setBadgeText = function (badgeText){};
    this.getTitle = function (callback) {}; // callback format function (string result) {};
    this.setTitle = function (title, callback){}; // callback format function (string result) {};
    this.setIcon = function (iconurl, callback){}; // callback format function (string result) {};
    this.enable = function (){}; // Different to chrome, the enalbe/disable is apply to all tabs.
    this.disable = function (){}; // Different to chrome, the enalbe/disable is apply to all tabs.
    this.onClicked = new Event("browseractiononclick", this.sogoumse);
}

function BrowserUtility(sogoumse) {
    this.sogoumse = sogoumse;
    
    this.browserUUID = function (callback) {
    	var index = addCallback(this.sogoumse,callback);
    	var temTabId ;
    	 // tabid 为全局变量，闭包创创建里初始化, 后台时,未定义
    	if(typeof tabid ==='undefined'){
    		temTabId='undefined';
    	}else{
    		temTabId = tabid;
    	}
       sogoumse_interface.getBrowserUUID( this.sogoumse.name ,temTabId ,index);
    }
    
    this.signature = function(code, callback){
    	var index = addCallback(this.sogoumse,callback);
    	var temTabId ;
   	  if(typeof tabid ==='undefined'){
   		  temTabId='';
   	  }else{
   		  temTabId = tabid;
   	}
    	sogoumse_interface.signature( this.sogoumse.name ,temTabId , code ,index);
    }
    
    this.showDRScanner = function (callback) {
    };
    
 
    this.browserInfo = function(callback){
    	var index = addCallback(this.sogoumse,callback);
    	sogoumse_interface.browserInfo( this.sogoumse.name ,index);
    };

    this.shareWithInfo = function(data,cb){
          if(typeof cb !=='function'){
            cb = function(){};
          } 
          var index = addCallback(this.sogoumse,callback);
           var temTabId ;
   	  if(typeof tabid ==='undefined'){
   		  temTabId='';
   	  }else{
   		  temTabId = tabid;
   	}
        sogoumse_interface.shareWithInfo( this.sogoumse.name ,temTabId, JSON.stringify(data),index);
       };

    this.forceScreenLight = function(keepScreenOn) {
        sogoumse_interface.forceScreenLight(keepScreenOn);
    };

    this.writeStr = function(key, value) {
        sogoumse_interface.writeStr(key, value);
    };

    this.readStr = function(key) {
        return sogoumse_interface.readStr(key);
    };
}

function Sogoumse(name) {
    this.name = name;
    this.callbacks = {};
    this.tabs = new Tabs(this);
    this.extension = new Extension(this);
    this.quickLaunch = new QuickLaunch(this);
    this.browserUtility = new BrowserUtility(this);
    this.browserAction = new BrowserAction(this);
}


function log() {
  var debug = false;
  if ( debug ) {
    for ( var i = 0, l = arguments.length; i < l; i++ ) {
      var logvar = arguments[i];
      if(typeof arguments[i] == 'object'){
          logvar = JSON.stringify(arguments[i]);
      }
      console.log( logvar );
    }
  }
}

